﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;

namespace dynamicseries
{
    class simpledatacollection : ObservableCollection<DynamicClass>
    {
        public simpledatacollection()
        {

            DataTable dtseries = new DataTable("dtseries");
            dtseries.Columns.Add("Label1");
            dtseries.Columns.Add("Value1");
            dtseries.Columns.Add("Value2");

            for (int i = 1; i <= 10; i++)
            {
                DataRow dr = dtseries.NewRow();
                dr["Label1"] = i.ToString();
                dr["Value1"] = i;
                dr["Value2"] = Convert.ToDouble(i);
                dtseries.Rows.Add(dr);
            }

            for (int curRec = 0; curRec < dtseries.Rows.Count; curRec++)
            {
                var dynamicClass = new DynamicClass();

                for (int i = 0; i < dtseries.Columns.Count; i++)
                {
                    dynamicClass.property[dtseries.Columns[i].ColumnName] = dtseries.Rows[curRec][dtseries.Columns[i].ColumnName];
                }

                this.Add(dynamicClass);
            }

        }
    }

    public class DynamicClass
    {
        // property is a class that will create dynamic properties at runtime

        private DynamicProperty _property = new DynamicProperty();

        public DynamicProperty property
        {
            get { return _property; }
            set { _property = value; }
        }
    }

    public class DynamicProperty
    {

        private Dictionary<string, object> properties = new Dictionary<string, object>();

        public object this[string name]
        {
            get
            {
                if (properties.ContainsKey(name))
                {
                    return properties[name];
                }
                return 0;
            }
            set
            {
                properties[name] = value;
            }
        }
    }
}
